package com.draw.painting.line.ui;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.PickVisualMediaRequest;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.camera.core.Camera;
import androidx.camera.core.CameraSelector;
import androidx.camera.core.ImageCapture;
import androidx.camera.core.Preview;
import androidx.camera.lifecycle.ProcessCameraProvider;
import androidx.camera.view.PreviewView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import android.Manifest;
import android.app.Activity;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.graphics.Point;
import android.graphics.PointF;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.ParcelFileDescriptor;
import android.provider.MediaStore;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.SeekBar;
import android.widget.Toast;

import com.google.common.util.concurrent.ListenableFuture;
import com.draw.painting.line.DrawingApp;
import com.draw.painting.line.R;
import com.draw.painting.line.manager.AppHelper;

import java.io.File;
import java.io.IOException;
import java.util.Objects;

public class DrawActivity extends AppCompatActivity implements View.OnTouchListener, View.OnClickListener {
    private CameraSelector cameraSelector;
    private String[] permissions;
    private int range;
    private Camera camera;
    private ImageCapture imageCapture;
    private PreviewView previewView;
    private ImageView imageView;
    private SeekBar seekBar;

    private Double d;


    private int MODE;//当前状态
    public static final int MODE_NONE = 0;//无操作
    public static final int MODE_DRAG = 1;//单指操作
    public static final int MODE_SCALE = 2;//双指操作

    private Matrix startMatrix;
    private Matrix endMatrix = new Matrix();//变化后的矩阵
    private PointF startPointF = new PointF();//初始坐标
    private float distance;//初始距离
    private float scaleMultiple;//缩放倍数

    private ImageView flashIm, imZoom, imBack;
    private ImageView imPhoto;
    private View llTool;

    private String curBitmapPath;
    private boolean hasPermission = false;

    private ActivityResultLauncher<PickVisualMediaRequest> pickImageLauncher;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        AppHelper.enableEdgeToEdge(this);
        setContentView(R.layout.activity_draw);
        previewView = findViewById(R.id.preview);
        imageView = findViewById(R.id.image);
        imBack = findViewById(R.id.back);
        AppHelper.setupStatusBarMargin(imBack);

        seekBar = findViewById(R.id.seekbar);
        flashIm = findViewById(R.id.im_flash);
        imPhoto = findViewById(R.id.im_photo);
        imZoom = findViewById(R.id.im_zoom);
        llTool = findViewById(R.id.ll_tool);
        AppHelper.setupBottomNavMargin(llTool, 24); // 24dp 额外间距
        curBitmapPath = getIntent().getStringExtra(DrawingApp.Key_Camera);

        pickImageLauncher = registerForActivityResult(new ActivityResultContracts.PickVisualMedia(), imageUri -> {
            if (imageUri == null) {
                Toast.makeText(this, getString(R.string.permission_fail), Toast.LENGTH_SHORT).show();
                Log.d("-------------------tt", "-------imageUri-111-null");
                return;
            }
            double uriFileSize = getUriFileSize(DrawActivity.this, imageUri);
            if (uriFileSize >= 4) {
                Toast.makeText(this, getString(R.string.file_fail), Toast.LENGTH_SHORT).show();
                Log.d("-------------tt", "-------imageUri---222-uriFileSize=" + uriFileSize);
                return;
            }
//                Log.d("--------------tt","------bitmap-----width="+width+"-----height="+height);
            Log.d("-------------tt", "-------imageUri---333-uriFileSize=" + uriFileSize);
            imageView.setImageURI(imageUri);
        });

        init();
        initClick();
    }

    private void onInitIm(float imW, float imH) {
        Point screen = AppHelper.getScreen(this);
        float newX = screen.x / 2f - imW / 2;
        float newY = screen.y / 2f - imH / 2;
        startMatrix = new Matrix();
        startMatrix.postTranslate(newX, newY);
        imageView.setImageMatrix(startMatrix);

        Log.d("---------------tt", "------startMatrix-----x=" + newX + "------y=" + newY);
    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {
        switch (event.getAction() & event.getActionMasked()) {
            case MotionEvent.ACTION_DOWN:

                startMatrix.set(imageView.getImageMatrix());
                endMatrix.set(imageView.getImageMatrix());

                startPointF.set(event.getX(), event.getY());


                Log.d("---------------tt", "------ACTION_DOWN-----x=" + event.getX() + "------y=" + event.getY());

                MODE = MODE_DRAG;

                break;
            case MotionEvent.ACTION_POINTER_DOWN:

                startMatrix.set(endMatrix);

                distance = AppHelper.getDistance(event);

                MODE = MODE_SCALE;

                break;
            case MotionEvent.ACTION_MOVE://滑动（单+双）
                if (MODE == MODE_DRAG) {//单指滑动时

                    endMatrix.set(startMatrix);
                    //向矩阵传入位移距离
                    endMatrix.postTranslate(event.getX() - startPointF.x, event.getY() - startPointF.y);
                    Log.d("---------------tt", "------ACTION_MOVE-----x=" + event.getX() + "------y=" + event.getY());
                } else if (MODE == MODE_SCALE) {//双指滑动时
                    //计算缩放倍数
                    scaleMultiple = AppHelper.getDistance(event) / distance;
                    //获取初始矩阵
                    endMatrix.set(startMatrix);
                    //向矩阵传入缩放倍数
                    endMatrix.postScale(scaleMultiple, scaleMultiple, startPointF.x, startPointF.y);
                }
                break;
            case MotionEvent.ACTION_UP://单指离开
            case MotionEvent.ACTION_POINTER_UP://双指离开
                //手指离开后，重置状态
                MODE = MODE_NONE;

                break;
        }
        //事件结束后，把矩阵的变化同步到ImageView上
        imageView.setImageMatrix(endMatrix);
        return true;
    }

    @Override
    public void onClick(View v) {
        if (v.equals(imBack)) {
            finish();
        } else {
            if (!hasPermission) {
                showNoPermission();
                return;
            }
            if (v.equals(flashIm)) {
                if (camera == null) {
                    return;
                }
                boolean selected = flashIm.isSelected();
                flashIm.setSelected(!selected);
                camera.getCameraControl().enableTorch(!selected);
            } else if (v.equals(imPhoto)) {
                pickImageLauncher.launch(
                        new PickVisualMediaRequest.Builder()
                                .setMediaType(ActivityResultContracts.PickVisualMedia.ImageOnly.INSTANCE)
                                .build()
                );
            } else if (v.equals(imZoom)) {
                if (seekBar.getVisibility() == View.VISIBLE) {
                    seekBar.setVisibility(View.GONE);
                    imZoom.setSelected(false);
                } else if (seekBar.getVisibility() == View.GONE) {
                    seekBar.setVisibility(View.VISIBLE);
                    imZoom.setSelected(true);
                }
            }
        }

    }

    private void initClick() {
        imBack.setOnClickListener(this);
        flashIm.setOnClickListener(this);
        imPhoto.setOnClickListener(this);
        imZoom.setOnClickListener(this);
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                float v = (seekBar.getMax() - progress) / 10.0f;
                imageView.setAlpha(v);

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    private void init() {
        cameraSelector = CameraSelector.DEFAULT_BACK_CAMERA;
        permissions = new String[]{android.Manifest.permission.CAMERA};
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            permissions = new String[]{android.Manifest.permission.CAMERA};
        } else {
            permissions = new String[]{android.Manifest.permission.CAMERA};
        }
        if (!checkPermission()) {
            hasPermission = false;
            imageView.setOnTouchListener(null);
            ActivityCompat.requestPermissions(this, permissions, 0);
        } else {
            hasPermission = true;
            imageView.setOnTouchListener(this);
            startCamera();
        }
    }

    private void startCamera() {
        ListenableFuture<ProcessCameraProvider> future = ProcessCameraProvider.getInstance(this);
        future.addListener(() -> {
            try {
                ProcessCameraProvider cameraProvider = future.get();

                Preview preview = new Preview.Builder().build();
                cameraProvider.unbindAll();
                ImageCapture.Builder builder1 = new ImageCapture.Builder();
                imageCapture = builder1.build();
                camera = cameraProvider.bindToLifecycle(this, cameraSelector, preview, imageCapture);
                if (camera != null) {
                    range = AppHelper.getRange(camera);
                }
                preview.setSurfaceProvider(previewView.getSurfaceProvider());

                if (curBitmapPath != null) {
                    Bitmap bitmap = AppHelper.loadImageFromAssets(this, curBitmapPath);
                    imageView.setImageBitmap(bitmap);
                    int width = bitmap.getWidth();
                    int height = bitmap.getHeight();
                    onInitIm(width, height);


                }

            } catch (Exception e) {
                e.printStackTrace();
            }
        }, ContextCompat.getMainExecutor(this));

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == 0) {
            if (checkPermission()) {
                hasPermission = true;
                imageView.setOnTouchListener(this);
                startCamera();
            } else {
                hasPermission = false;
                imageView.setOnTouchListener(null);
            }

        }
    }


    private boolean checkPermission() {
        boolean result = true;
        for (String per : permissions) {
            if (ActivityCompat.checkSelfPermission(this, per) != PackageManager.PERMISSION_GRANTED) {
                result = false;
            }
        }
        return result;

    }

    private void showNoPermission() {
        Toast.makeText(this, getString(R.string.permission_fail), Toast.LENGTH_SHORT).show();
    }

    public static double getUriFileSize(Context context, Uri uri) {
        double fileSize = 0.0;
        ContentResolver contentResolver = context.getContentResolver();
        if ("file".equals(uri.getScheme())) {
            File file = new File(Objects.requireNonNull(uri.getPath()));
            if (file.exists()) {
                fileSize = (double) file.length();
            }
        } else {
            ParcelFileDescriptor pfd = null;
            try {
                pfd = contentResolver.openFileDescriptor(uri, "r");
                if (pfd != null) {
                    fileSize = (double) pfd.getStatSize();
                }
            } catch (Exception e) {
                Log.e("UriUtils", "Error while retrieving file size: " + e.getMessage(), e);
            } finally {
                if (pfd != null) {
                    try {
                        pfd.close();
                    } catch (IOException e) {
                        // ignore
                    }
                }
            }
        }
        return fileSize / 1048576.0;
    }
}

